     /*  Created on: Nov 7, 2012
     *      Author: Novotny
		 *   Obsluha udalosti z ovladacich tlacitek, psani textu na displej
     */
     
    /* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f0xx_gpio.h"
#include "stm32f0xx_LCD.h"
#include "stm32f0xx_rcc.h"
#include "string.h"
#include "stm32f0xx_it.h"
#include "obsluha_rozhrani_HMI.h"
#include "arm_math.h"
#include "stm32f0xx_my_config.h"

    /** Private_TypesDefinitions    */
     
    /** Private_Defines             */
     
    /** Private_Macros              */

/** Private_Variables                */
uint8_t odber_bezi=0;					// bit s informaci o probihajicim odstartovanem mereni
extern uint16_t ADC_akt_hodnota;  
uint8_t LCD_text[]="xxxxxxxxxxxxxxxx";

uint8_t poz_hodnota;					// promena pro pozadovanou hodnotu stredni elektrol,stredni aritm, efektivni

// prednastavene hodnoty
uint32_t hodnota=1024; 					// promena nastavene hodnoty
uint32_t zbyva_vzorku=0;				// zbyvajici pocet vzorku


/** Private_Functions*/

void start_prenos(void);


/********************************************************************************************/
/********************************	MENU NASTAVENI VOLTMETRU  ********************************/
/********************************************************************************************/
/**
  * @brief  Zobrazeni Menu s obsluhou vyberu polozky
  * @param  : None
  * @retval : None
  */
void display_start_text()
{
	poz_hodnota=0; 							// nastaveni uvodniho rezimu mereni
	set_cursor(0,0);	 				  // nastavi pozici cursoru LCD na (sloupec, radek)
		printLCD("    Voltmetr    ");
	set_cursor(0,1);
		printLCD("  STM32F051R8   ");
	Delay(1000);
	
	LCD_Clear();
	display_zobraz_rezim();
}

/**
  * @brief  Testovani tlacitka a zmena volby o jednu polozku v menu, 
  * @param  : None
  * @retval : None
  */
void zmen_zobrazeni()
{		
	Delay(30);    //filtr		
	
	if(!(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0))) 			// kontrola stisku tlacitka		
	{					
		poz_hodnota=poz_hodnota+1;  //inkrementace volby
		if(poz_hodnota>4)        		//pocet polozek menu
		{
			poz_hodnota=0;						// vrati hodnotu na zacatek->kruhova volba 
		}  	     		
		display_zobraz_rezim();
		while(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)){} // ve smycce pokud je stisknuto tlacitko SET ceka az se pusti			
	}				
}		 			 		

/**
  * @brief  Zobrazeni rezimu merene hodnoty na displeji 
  * @param  : None
  * @retval : None
  */
void display_zobraz_rezim()
{
						// ***************Prvni radek****************************************
		//LCD_Clear();
					switch(poz_hodnota) 		// spusteni akce v zavislosti na zvolene volbe
						{	
								case(0):set_cursor(0,0);printLCD("Maximalni napeti");break;  
								case(1):set_cursor(0,0);printLCD("Minimalni napeti");break; 
								case(2):set_cursor(0,0);printLCD("Stred. elektrol.");break; 
								case(3):set_cursor(0,0);printLCD("Stred. aritmet. ");break; 
								case(4):set_cursor(0,0);printLCD("Efektivni napeti");break; 
								default:set_cursor(0,0);printLCD("xxxxxx mer xxxxx");break;  
						}	
		// *************** Druhy radek****************************************
		set_cursor(13,1);
		printLCD("mV");
}
// testuje stisk tlacitka set
uint8_t test_tlac_SET()
{
	if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0))
	{
		Delay(50);
	}
	if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0))
		return 1;
	else
		return 0;
}

/**
  * @brief  Spusti odmery hodnot z ADC
  * @param  : None
  * @retval : None
  */
void spust_odbery()
{			
	TIM2->EGR|=0x1;    	// UG  update generation provede update registru citace CNT,a prvni odmer		
	TIM2->CR1|=0x1;			// timer enable
}

/**
  * @brief  Obnoveni hodnoty udaje displeje pri mereni
  * @param  : hodnota pro zobrazeni
  * @retval : None
  */
void zobraz_data_signal(int16_t hodnota) 		// obnoveni hodnot displeje pri mereni
{	
	set_cursor(5,1);
	itoa(hodnota,LCD_text);	
	printLCD(LCD_text);	
}


