/*Voltmetr knihovna pro vpoet hodnot napt ze vzork*/

#include "stm32f0xx_voltmetr.h"
#include "main.h"
#include "math.h"
#include "stm32f0xx_adc.h"

int16_t max_hodn=0;        //udrzuji vysledky vypoctenych hodnot
int16_t min_hodn=0;
int16_t elektrol_hodn=0;
int16_t aritm_hodn=0;
int16_t efektiv_hodn=0;
int16_t posl_max;      			// zde jsou namerene hodnoty vysledky
int16_t posl_min;			 			// zde jsou namerene hodnoty vysledky
double soucet_elektrol=0;
double soucet_aritm=0;
double soucet_efektiv=0;

/**
  * @brief  Cteni dat z registru ADC prevodniku
  * @param  : None
  * @retval : hodnota registru ADC_DR
  */
uint16_t ADC1_Read(void)
{
  return ADC_GetConversionValue(ADC1);
}

void najdi_max_hodn(int16_t odecet)									 // vypocet max hodnoty napeti
{
		if(max_hodn<odecet) 		//	porovnani nactene a nove hodnoty
				max_hodn=odecet;		//kdyz je nova hodnota vetsi aktualizuje se hodn max	
}

void najdi_min_hodn(int16_t odecet)									 // vypocet max hodnoty napeti
{
		if(min_hodn>odecet) //porovnani a inkrement ukazatele
		min_hodn=odecet;			
}

void vypocti_stredni_elektrolyt_hodn(int16_t odecet,int16_t *pInt)   // vypocet stredni elektrolytick hodnoty napeti
{	
	soucet_elektrol=soucet_elektrol-*pInt; 		// odecteni nejstarsi hodnoty ze sumy souctu	
	soucet_elektrol=soucet_elektrol+(odecet);	// do suma hodnot pricte novy odecet	
  elektrol_hodn=uprav_meritko((double)(soucet_elektrol/POCET_VZORKU));		//prumerovani  zmena meritka
}

void vypocti_stredni_aritm_hodn(int16_t odecet,int16_t *pInt)   		 // vypocet stredni aritmeticke hodnoty napeti |u(t)|
{		
	// odecteni nejstarsiho vzorku v absolutni hodnote ze sumy souctu
	  if(*pInt<=0)  												// stara hodnota je zaporne cislo
			soucet_aritm=soucet_aritm+*pInt;		// odeber zaporne cislo tim ze ho prictes, tim se hodnota eliminuje
		else
			soucet_aritm=soucet_aritm-*pInt;		// pridej kladne cislo tim ze ho prictes, tim se hodnota eliminuje

		// pricteni noveho vzorku v absolutni hodnote
	  if(odecet<=0)  												// nactena hodnota je zaporne cislo
			soucet_aritm=soucet_aritm-odecet;		// pridej zaporne cislo jako ABS hodnotu
		else
			soucet_aritm=soucet_aritm+odecet;		// pridej kladne cislo jako ABS hodnotu
		
		//prumerovani  zmena meritka
  aritm_hodn=uprav_meritko((double)(soucet_aritm/POCET_VZORKU));
}

void vypocti_efektivni_hodn(int16_t odecet,int16_t *pInt)		// vypocet efektivni hodnoty napeti RMS
{
	double odmocnina=0;
	soucet_efektiv=soucet_efektiv-(*pInt)*(*pInt);				// odecteni nejstarsiho vzorku v hodnote kvadratu ze sumy souctu
	soucet_efektiv=soucet_efektiv+odecet*odecet;		// pricteni noveho vzorku v hodnote kvadratu
	
	odmocnina=sqrt((double)(soucet_efektiv/POCET_VZORKU));		//prumerovani a vypocet odmocniny
	efektiv_hodn=uprav_meritko(odmocnina);	   								// uprava meritka na rozsah -1500 az +1500 [mV]
}
// uprava meritka pro zobrazeni skutecne hodnoty
int16_t uprav_meritko (double vstup)
{ 
	 int16_t test=0;
	double scale;
	scale=(vstup/ROZL_ADC)*(REF_NAPETI*1000);  //nasobeni 1000 pro vystup v mV
	test=(int16_t)scale;
	return test;
}
