#include "frekvence.h"
#include "stm32f0xx_gpio.h"
#include "stm32f0xx_rcc.h"
#include "stm32f0xx.h"
#include "stm32f0xx_my_config.h"

float perioda=0.0;
float frekvence=0.0;



// 
/**
  * @brief  : Nastaveni periferi TIM2 citac, TIM1 hradlo pro TIM2
  * @param  None
  * @retval None
	* @note		: prime mereni frekvence
  */
void frequencySetTIM1_TIM2() 
{	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE); 	// povoleni hodin do periferie

	GPIOA->OSPEEDR|=0xC00;  		//PA5 50MHz
	GPIOA->MODER|=0x800;	      //AF function pro vstup PA5	
	GPIOA->AFR[0]|=0x200000;	  //AFRL nastaveni PA5 na AF2(TIM2_CH1_ETR)

	GPIOA->MODER|=0x2000;	      //AF function pro vstup PA6
	GPIOA->AFR[0]|=0x7000000;	  //AFRL nastaveni PA6 na AF7(COMP1_OUT)
	
	// hradlovaci generator zdroj pulsu
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);	// povoleni hodin do periferie
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);	// povoleni hodin do periferie
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);	// povoleni hodin do periferie COMP hodiny jsou spolecne s SYSCFG
	
	//nastaveni pro sestavu TIM1+TIM2
	TIM1->CR1|=0x8;      // OPM one pulse mode zastaven po UEV  nutno smazatCEN
	TIM1->ARR=10000;		 // 48000 pulsu pr f=48MHz pretece za 1ms
	TIM1->PSC=4799; 		 // frequency 48MHz 	POZOR frekvence odpovida psc+1
	TIM1->CR2|=0x10;     // Master mode selection MMS=001 enable CNT_EN je pouzit jako trigger TRG0
	TIM1->DIER|=0x01;	 	 // UIE povoleni update interrupt
	TIM1->CR1|=0x01;	 	 //counter enable

	// komparator nastaveni pro vstup signalu
	COMP->CSR|=0x2000;  //COMP1HYST=10(medium) Comparator 1 hysteresis
	COMP->CSR|=0x500;   //COMP1OUTSEL=101: Timer 2 OCrefclear input: Comparator 1 output selection
	COMP->CSR|=0x30;	 	//COMP1INSEL=011:  1,2V Vrefint: Comparator 1 inverting input selection
	COMP->CSR|=0x0;	 		//COMP1MODE=00: High speed / full power: Comparator 1 mode
	COMP->CSR|=0x1;	 		//COMP1EN: Comparator 1 enable
	
		//tim2 jako citac pulsu nezname frekvence
	TIM2->ARR=0xFFFFFFFF;	 // pretece za 89s
	TIM2->PSC=0x0; 				 //sampling frequency 48MHz 
	TIM2->SMCR|=0x80;      //MSM bit  synchronization
	TIM2->SMCR|=0x05;	 		 //SMS=101 Gated mode	
	TIM2->SMCR|=0x4000;		 // ECE=1 external clock mode 2enable		
	TIM2->CR1|=0x01;	 		 //counter enable	
}

