
#include "stm32f0xx.h"

/**
  * @brief  Nastaveni periferie GPIOA, TIM2 pro rezim PWM1
  * @param  None
  * @retval None
  */
void PWM_SetTIM2()				// konfigurace TIM2 pro generovani PWM	 
{	
	RCC->APB1ENR|=0x001; 				//povoleni hodin do periferie GPIOA
	RCC->AHBENR|=0x20000; 			//povoleni hodin do periferie TIM2
	
	GPIOA->OSPEEDR|=0xC0000000;	//fast mode pro PA15 (5 ns)
	GPIOA->MODER|=0x80000000;	  //AF function pro vstup PA15
	GPIOA->AFR[1]|=0x20000000;	//AFRL nastaveni PA15 na AF2(TIM2_CH1_ETR)

	// nastaveni TIM2 pro generovani PWM1
	TIM2->PSC=0; 								//prescaler frequency (48MHz deleni=(PSC=0)+1) (pro 1MHz PSC=47(POZOR automaticky se pricita+1)) 
	TIM2->ARR=48000;						//defaultni nastaveni frekvence opakovani 
	TIM2->CCR1=12000;						//defaultni nastaveni delky pulsu 
	TIM2->CCMR1|=0x60; 					//PWM mode 1, channel is inactive if TIM2_CNT>TIM2_CCR 
	TIM2->CCER=0x01;	 					//OC1 je vystup pro korespondujici pin
	TIM2->CR1|=0x01;	 					//counter enable
}

