
 /*  Created on: Nov 7, 2012
*      Author: Novotny
*/
     
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f0xx_gpio.h"
#include "stm32f0xx_LCD.h"
#include "stm32f0xx_rcc.h"
#include "string.h"
#include "stm32f0xx_it.h"
#include "obsluha_klaves_generator.h"
#include "arm_math.h"

    /** Private_TypesDefinitions    */
     
    /** Private_Defines                     */
     
    /** Private_Macros                      */

/** Private_Variables                   */
#define max_frekv 500000.00		//hodnota maximalni nastavitelne frekvence
extern int scale_freq;        // meritko mezi nastavenim frekvence a hodnotou pro realne pricitani k adrese reg DDS  
int pocet_radu=6;   					// pocet radu nastaveni frekvence
extern uint32_t faze;
uint8_t LCD_text[]="xxxxxxxxxxxxxxxx";
int volba_prubehu=0; 					// kod pro nahrani prubehu do pameti
int poz_frekv=0; 							// nastaveni pozadovane vystupni frekvence signalu


    /** Private_Functions                   */

void obnov_data_display(int rad);
void 	nastav_frekv(int rad);

/********************************************************************************************/
/*******************************	ZADAVANI FAZE - (FREKVENCE) *******************************/
/********************************************************************************************/
/**
  * @brief  Nastaveni faze neboli frekvence generatoru
  * @param  None
  * @retval pozadovana frekvence
  */
void nastav_fazi()
{ 
	int t;
	
	LCD_Clear();
	set_cursor(0,0);	 			 	// nastavi pozici cursoru LCD na (sloupec, radek)
		printLCD("Nast. frekvence ");
		Delay(1500);
  set_cursor(0,0);   
		printLCD("Potvrzeni-> SET");
	
	set_cursor (3,1);
	PosliPrikazLCD(0x0F);			// 0b00001111 zapnuti blikani kurzoru aby se vedelo kde se nastavuje
	
	for(t=0;t<pocet_radu;t++)
	{	while(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) // cekani na stisk tlacitka posunuti na vyssi rad
		{} 
			Delay(50);
			nastav_frekv(t);
	}
	faze=scale_freq*poz_frekv;   // ulozeni nastaveni pridavku faze k registru DDS
  PosliPrikazLCD(0x0C);				 // 0b00001110 vypnuti blikani kurzoru             
	Delay(100);
}

void obnov_data_display(int rad) //obnoveni udaje o fazi na displeji
{
			set_cursor(3,1);
				itoa(poz_frekv,LCD_text);
				printLCD(LCD_text);
      set_cursor(13,1);
				printLCD("Hz");		
			set_cursor (12-rad,1);  // nastaveni kurzoru do pozice zmeny
}

void nastav_frekv(int rad)
{
		while(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) //uvolnene tlacitko zadava se
		{ obnov_data_display(rad);  										 // vykresli nast hodnotu na display
			if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))  //indikuje sepnuti tlacitka
			{
				poz_frekv=poz_frekv+pow(10,rad);
				if(poz_frekv>max_frekv)
				{poz_frekv=max_frekv;}
			}
			if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))
			{
				poz_frekv=poz_frekv-pow(10,rad);
				if(poz_frekv<0)
				{poz_frekv=poz_frekv+pow(10,rad);}
			}
			while((!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))||(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2)))
			{}  						// pro zmenu hodnoty neni mozne drzet stisknute tlacitko zustane v teto smycce
			Delay(50);
	  }
}

/********************************************************************************************/
/********************************	VOLBA POZADOVANEHO PRUBEHU ********************************/
/********************************************************************************************/
/**
  * @brief  Nastaveni tvaru vystupniho signalu generatoru
  * @param  None
  * @retval naplneni poleDat[] pozadovanymi daty 
  */
void nastav_prubeh()
{			
			LCD_Clear();
				set_cursor(0,0);	 					 // nastavi pozici cursoru LCD na (sloupec, radek)
			printLCD("Nast. tvar vyst.");
				Delay(1500);
	
				set_cursor(0,0);   
			printLCD("Potvrzeni-> SET");
	
		while(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) // ve smycce pokud neni stisk tlacitka PA0
		{										
					if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))
					{
						if(volba_prubehu<4)
							{volba_prubehu=volba_prubehu+1;} 				//nast max poctu defin. prubehu
					}						
					if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))
					{
						if(volba_prubehu>0)
							{volba_prubehu=volba_prubehu-1;}	
					}		
					while((!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))||(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))) //cekani pokud je stiskle tlacitko + nebo -
						{}
					Delay(50); //filtr zakmitu
					
			 	 switch(volba_prubehu)
					{
						case(1):set_cursor(0,1);printLCD("     SINUS      ");break;  //vypis na display		
						case(2):set_cursor(0,1);printLCD("      PILA      ");break;  //vypis na display	
						case(3):set_cursor(0,1);printLCD("    OBDELNIK    ");break;  //vypis na display	
						default:set_cursor(0,1);printLCD("Volba tlacit +,-");break;  //vypis na display
					}
		 }
			  switch(volba_prubehu)
			 {
			 case(1):createTabSin();break;  			//vytvoreni tabulky dat vypoctem sinusoveho vzoru	
			 case(2):createTabPila();break;  			//vytvoreni tabulky dat vypoctem piloveho vzoru	
			 case(3):createTabObdelnik();break;  	//vytvoreni tabulky dat vypoctem obdelnikoveho vzoru	
			 default:nastav_prubeh();break;				//opakovani volby
			 }			 		
}
void zobraz_data_signal()
{
	switch(volba_prubehu)
					{
						case(1):set_cursor(0,0);printLCD("Generovani  Sin ");break;  //vypis na display		
						case(2):set_cursor(0,0);printLCD("Generovani  Pila");break;  //vypis na display	
						case(3):set_cursor(0,0);printLCD("Gener. Obdelnik ");break;  //vypis na display	
						default:set_cursor(0,0);printLCD("Nenastav. prubeh");break;  //vypis na display
					}
					obnov_data_display(0);
}


