     /*  Created on: Nov 7, 2012
     *      Author: Novotny
		 *   Obsluha udalosti z ovladacich tlacitek, psani textu na displej
     */
     
    /* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f0xx_gpio.h"
#include "stm32f0xx_LCD.h"
#include "string.h"
#include "stm32f0xx_it.h"
#include "obsluha_rozhrani_HMI.h"
#include "arm_math.h"
#include "stm32f0xx_my_config.h"

    /** Private_TypesDefinitions    */
     
    /** Private_Defines             */
     
    /** Private_Macros              */

/** Private_Variables                */

uint8_t LCD_text[]="xxxxxxxxxxxxxxxx";
uint32_t max_hodn =0xffffffff;		// maximalni nastavitelna hodnota

/** Private_Functions*/

/********************************************************************************************/
/***************************	MENU NASTAVENI LCD display  ***********************************/
/********************************************************************************************/
/**
  * @brief  Zobrazeni startovaciho textu
  * @param  : None
  * @retval : None
  */
void display_start_text()
{
	set_cursor(0,0);	 				  // nastavi pozici cursoru LCD na (sloupec, radek)
		printLCD(" PWM generator  ");
	set_cursor(0,1);
		printLCD("  STM32F051R8   ");
	Delay(1000);
} 			 		

/**
  * @brief  zobrazeni textu menu na display pri nastavovani 
  * @param  : None
  * @retval : None
  */
void display_zobraz_rezim(uint8_t volba)
{
						// ***************Prvni radek+Druhy radek***************************************
		//LCD_Clear();
					switch(volba) 		// spusteni akce v zavislosti na zvolene volbe
						{	
								case(0):set_cursor(0,0);printLCD("    tim_arr    ");set_cursor(13,1);break;  
								case(1):set_cursor(0,0);printLCD("    tim_crr    ");set_cursor(13,1);break;  
								default:set_cursor(0,0);printLCD("xxxxxx mer xxxxx");break;  
						}		
}

/**
  * @brief  obnovuje data po zmene jejich hodnoty
  * @param  : None
  * @retval : None
  */
void obnov_data_display(uint32_t *hodnota,int rad) //obnoveni udaje o fazi na displeji
{   
			set_cursor(3,1);
				itoa(*hodnota,LCD_text);
				printLCD(LCD_text);	
			set_cursor (13-rad,1);  // nastaveni kurzoru do pozice zmeny
}

/**
  * @brief  : nastaveni hodnot v parametru TIM2 arr, ccr
  * @param  : None
  * @retval : nastaven hodnota
  */

void nastav_hodnotu(uint32_t *hodnota)
{
	int rad;    // pozice radu ktera se aktualne edituje
	Delay(50);
	PosliPrikazLCD(0x0F);			// 0b00001111 zapnuti blikani kurzoru aby se vedelo kde se nastavuje

	
	for(rad=0;rad<10;rad++)  // prochazi se vsechny rady
	{ 	
		obnov_data_display(hodnota,rad);  						 // vykresli nast hodnotu na display
		while(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) // pokud je stiskle tlacitko zustava ve smycce
		{}
		Delay(50);
		while(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) //uvolnene tlacitko zadava se
		{ 
			if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))  //indikuje sepnuti tlacitka "+"
			{
				*hodnota=*hodnota+pow(10,rad);
				if(*hodnota>max_hodn) 												// omezeni nastaveni na max hodnotu
				{
					*hodnota=max_hodn;
				}
		    /* omezeni maximalni hodnoty registru CCR
				if(TIM2->CCR1>=TIM2->ARR)         						// CCR1 registr nesmi byt vyssi nez ARR registr potom by nedoslo k sepnuti
				{
					TIM2->CCR1=TIM2->ARR-1;
				}*/
				TIM2->EGR=0x01;																// update generation, obnovi nastaveni
				obnov_data_display(hodnota,rad);  						// vykresli nove nast hodnotu na display
			}	
			if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))  	//indikuje sepnuti tlacitka "-"
			{
				*hodnota=*hodnota-pow(10,rad);
				/*if(TIM2->CCR1==0)         										// minimalni hodnota CCR registru 
				{
					*hodnota=1;																	//ukazatel ukazuje na CCR1
				}
				if(TIM2->ARR<2)         											// minimalni hodnota ARR registru 
				{
					*hodnota=2;
				}
				if(TIM2->CCR1>=TIM2->ARR)         						// CCR1 registr nesmi byt vyssi nez ARR registr potom by nedoslo k sepnuti
				{
					TIM2->CCR1=TIM2->ARR-1;
				}*/
				TIM2->EGR=0x01;																//update generation, obnovi nastaveni
				obnov_data_display(hodnota,rad);  						//vykresli nove nast hodnotu na display
			}
			while(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1)||!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))
			{}  						// pro zmenu hodnoty neni mozne drzet stisknute tlacitko zustane v teto smycce
			Delay(50);
	  }
		
	}
	  PosliPrikazLCD(0x0C);				 // 0b00001110 vypnuti blikani kurzoru  
	Delay(750);
}






