/**
  ******************************************************************************
  * @file    stm32f0xx_LCD.h 
  * @author  Pavel Novotny
  * @version V1.0.0
  * @date    18-May-2012
  * @brief   Library configuration file.
  ******************************************************************************
  * @attention
  *
  * allowed for free use
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __STM32F0XX_LCD_H
#define __STM32F0XX_LCD_H

/** @defgroup function 
  * @{
  */ 
void GPIO_LCD_Inicializace(void);
void LCD_Init(void);
void PosliPrikazLCD(uint8_t cmd);
void Posli4bitLCD(uint8_t c);
void PosliZnakLCD(uint8_t cmd);
void LCD_Clear(void);
void LCD_CursorHome(void);
void set_cursor (int sloupec, int radka);
void printLCD(uint8_t *retezec);
void printLCDc(const uint8_t *retezec);
void itoa(uint32_t n,uint8_t s[]);


/** @defgroup LCD_selection 
  * @{
  */ 
#define LCD_D4                     ((uint16_t)0x0001)  /*!< Pin 0 selected    */
#define LCD_D5		                 ((uint16_t)0x0002)  /*!< Pin 1 selected    */
#define LCD_D6			               ((uint16_t)0x0004)  /*!< Pin 2 selected    */
#define LCD_D7		                 ((uint16_t)0x0008)  /*!< Pin 3 selected    */

#define LCD_RS		                 ((uint16_t)0x0010)  /*!< Pin 4 selected    */
#define LCD_RW      		           ((uint16_t)0x0020)  /*!< Pin 5 selected    */
#define LCD_E		                   ((uint16_t)0x0040)  /*!< Pin 6 selected    */


#endif /* __LCD_H */


