/*Konfigurace periferi STM32F051*/


#include "stm32f0xx_my_config.h"
#include "stm32f0xx_gpio.h"
#include "stm32f0xx_rcc.h"
#include "stm32f0xx_adc.h"
#include "stm32f0xx_LCD.h"
#include "stm32f0xx_exti.h"


GPIO_InitTypeDef GPIO_InitStructure;
ADC_InitTypeDef  ADC_InitStructure;
EXTI_InitTypeDef EXTI_InitStructure;
RCC_ClocksTypeDef RCC_Clocks;


/********************************* GPIO **************************************/
void GPIO_my_config(void)
 {   
  /* GPIOx Periph clock enable */
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOC, ENABLE);
	 
 /* Configure PC8 as output pushpull mode */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8|GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_Init(GPIOC, &GPIO_InitStructure);
	 
	  /* Configure PA0 in input*/
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
	 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_2;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
	
 } 
 
/****************************** LCD display **************************************************/
void LCD_my_config(void) 
 {
			RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
	 /* Configure the GPIO Pins for LCD.*/
     
      GPIO_InitStructure.GPIO_Pin = LCD_E |LCD_RW | LCD_RS | LCD_D4 | LCD_D5
                      | LCD_D6 | LCD_D7 ;  
			GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
      GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
      GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
      GPIO_Init(GPIOB, &GPIO_InitStructure);
			LCD_Init();   // inicializace display 4 bit komunikace
 }

/***************************************** DCA ***********************************************/
	void DAC_my_config()   // vystup DMA je na PA4
	{
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_DAC, ENABLE);
	DAC->CR|=0x0001;		//DAC channel enable
	}

/******************************************** EXTI *******************************************/
void EXTI_my_config()
{
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);
	
	SYSCFG->EXTICR[0] |= SYSCFG_EXTICR1_EXTI0_PA;  // zdroj EXTI bude pin PA0
 	
  EXTI_StructInit(&EXTI_InitStructure);
	EXTI_InitStructure.EXTI_Line = EXTI_Line0;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);
	 /* Clear SC EXTI Line Pending Bit */
  EXTI_ClearITPendingBit(EXTI0_1_IRQn);

}

/****************************************** SYSTICK *******************************************/
void SYSTICK_my_config() 
{	 /* SysTick end of count event each 1ms */
  RCC_GetClocksFreq(&RCC_Clocks);
  SysTick_Config(RCC_Clocks.HCLK_Frequency / 1000);  //vyrabi preruseni po 1 ms 
}

/*************************************** NVIC *******************************************/
void NVIC_my_config()	 //nested vector interrupt 
{	
	/* specifikace line prichoziho preruseni line 1 a 0, stanoveni jeho priority(0 az 3) */ 
	 NVIC_SetPriority(EXTI0_1_IRQn, 7);  // set priority for EXTIx
   NVIC_SetPriority(SysTick_IRQn,100); // set priority for systick
	
	/* uvolneni preruseni z line 0 a 1 */
	NVIC_EnableIRQ(EXTI0_1_IRQn); // EXTI od PA0 tlacitka
}
	
