     /*  Created on: Nov 7, 2012
     *      Author: Novotny
		 *   Obsluha udalosti z ovladacich tlacitek, psani textu na displej
     */
     
    /* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f0xx_gpio.h"
#include "stm32f0xx_LCD.h"
#include "stm32f0xx_rcc.h"
#include "string.h"
#include "stm32f0xx_it.h"
#include "obsluha_rozhrani_HMI.h"
#include "arm_math.h"
#include "stm32f0xx_my_config.h"

    /** Private_TypesDefinitions    */
     
    /** Private_Defines             */
     
    /** Private_Macros              */

/** Private_Variables                */
#define max_hodn 99999					// hodnota maximalni nastavitelne frekvence omezeni 
int pocet_radu=5;   						// pocet radu nastaveni frekvence
uint32_t time_set_scale=0;   		// meritko nsoben zadn hodnoty intervalu odmeru v zavislosti na nastavenem casove jednotce zadavani 
int volba_t_base=0; 						// kod volby casove zakladny s nastavenim po startu 
uint8_t datalog_bezi=0;					// bit s informaci o probihajicim odstartovanem mereni
extern uint16_t ADC_akt_hodnota;  
uint8_t LCD_text[]="xxxxxxxxxxxxxxxx";
extern uint8_t storage [];			//odkaz na pole uloziste vzorku

// prednastavene hodnoty
uint32_t hodnota=1024; 					// promena nastavene hodnoty
uint32_t pocet_vzorku=0;				// pozadovany pocet vzorku
uint32_t zbyva_vzorku=0;				// zbyvajici pocet vzorku
uint32_t interval_odberu=01;		// pozadovany interval odberu vzorku



/** Private_Functions*/

void set_interval_odberu(void);
void set_pocet_vzorku(void);
void obnov_data_display(int rad);
void nastav_hodnotu(void);
void spust_odbery(void);
void start_prenos(void);


/********************************************************************************************/
/********************************	MENU NASTAVENI DATALOGGERU ********************************/
/********************************************************************************************/
/**
  * @brief  Zobrazeni Menu s obsluhou vyberu polozky
  * @param  : None
  * @retval : None
  */
void nastav_parametry()
{			
	int volba=1; 							// kod volby 
	   	LCD_my_config();			// reinit display obcas vypadne
			LCD_Clear();					// smazani displeje
			set_cursor(0,0);   
				printLCD("Vstup  ->   SET");
			set_cursor(0,1);	 		// nastavi pozici cursoru LCD na (sloupec, radek)
				printLCD("Vyber tlac. +,-");
				Delay(500);			
	
		while(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) // ve smycce pokud neni stisk tlacitka PA0
		{										
					if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))
					{ 
						volba=volba+1;  // inkrementace volby
						if(volba>6)
							{volba=1;}  	// nast max poctu defin. prubehu
					}						
					if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))
					{	
						volba=volba-1;
						if(volba<=0)
							{volba=6;}	
					}		
					while((!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))||(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))) //cekani pokud je stiskle tlacitko + nebo -
						{}
					Delay(50); 				// filtr zakmitu
					
			 	 switch(volba) 			// vypis vybrane nabidky na display	
					{	
						case(1):set_cursor(0,1);printLCD("      ZPET      ");break;  //vypis na display	
						case(2):set_cursor(0,1);printLCD("Start prenos->PC");break;  //vypis na display	
						case(3):set_cursor(0,1);printLCD("  SPUST ODBERY  ");break;  //vypis na display 
						case(4):set_cursor(0,1);printLCD("  STOP  ODBERY  ");break;  //vypis na display 	
						case(5):set_cursor(0,1);printLCD("  Pocet vzorku  ");break;  //vypis na display	
						case(6):set_cursor(0,1);printLCD("Interval vzork. ");break;  //vypis na display		
						default:set_cursor(0,1);printLCD("xxxxxxxxxxxxxxxx");break;  //vypis na display
					}
		}	// while end
		
					switch(volba) 		// spusteni akce v zavislosti na zvolene volbe
					{	
						case(2):set_cursor(0,1);start_prenos();break;  
						case(3):set_cursor(0,1);spust_odbery();break; 
						case(4):set_cursor(0,1);stop_odbery();break; 
						case(5):set_cursor(0,1);set_pocet_vzorku();nastav_parametry();break; 	
						case(6):set_cursor(0,1);set_interval_odberu();nastav_parametry();break; 
						default:set_cursor(0,1);break;  
					}		 			 		
}

/**
  * @brief  Prenos nactenych dat do PC po USART RS232
  * @param  : None
  * @retval : None
  */
void start_prenos() //prenos pole vyslednych hodnot do PC
{	int j;
	USART1->TDR=0x03;				 //	Vysle znak pro start prijmu dat softwarem NRM osciloskop
				while((USART1->ISR&0x80)==0);			//	kontrola zda byly data odeslany	
		for(j=0;j<pocet_vzorku;j++)
			{
				USART1->TDR=storage[j];						//	Vysle po USARTU hodnotu spodniho byte
				while((USART1->ISR&0x80)==0);			//	kontrola zda byly data odeslany					
		  }
}

/**
  * @brief  Spusti odmery hodnot z ADC
  * @param  : None
  * @retval : None
  */
void spust_odbery()
{
	if(volba_t_base==0||zbyva_vzorku==0) // nenastaven interval nebo pocet vzorku
	{
		datalog_bezi=0;
		if(volba_t_base==0)					// kdyz neni nastavena jednotka intervalu odebirani vzorku
			{	
			LCD_Clear();
			set_cursor(0,0);	 			 	// nastavi pozici cursoru LCD na (sloupec, radek)
			printLCD("Nastav. Interval");
			set_cursor(0,1);	 			 	// nastavi pozici cursoru LCD na (sloupec, radek)
			printLCD("   vzorkovani   ");
			Delay(2000);
			set_interval_odberu();		// spusteni funkce nastaveni intervalu vzorku
			}
		if(zbyva_vzorku==0)					// kdyz neni nastaven pocet vzorku
			{
			LCD_Clear();
			set_cursor(0,0);	 			 	// nastavi pozici cursoru LCD na (sloupec, radek)
			printLCD("Zbyva k mereni 0");
			set_cursor(0,1);	 			 	// nastavi pozici cursoru LCD na (sloupec, radek)
			printLCD("Nastav pocet vz.");
			Delay(2000);
			set_pocet_vzorku();  			// spusteni funkce nastaveni poctu vzorku
			}
			nastav_parametry();    		//navrat do menu nastaveni
	}
	else	
	{	
		TIM2->EGR|=0x1;    	// UG  update generation provede update registru citace CNT,a prvni odmer	
		TIM2->CR1|=0x1;			// timer enable
		datalog_bezi=1;	    // info pro zobrazeni informace odmery bezi
	}	
}

/**
  * @brief  Pozastavi cinnost TIM2, odebirani vzorku
  * @param  : None
  * @retval : None
  */
void stop_odbery()
{
	TIM2->CR1&=~0x1;						// timer disable
	datalog_bezi=0;	
}

/**
  * @brief  Obsluha nastaveni poctu vzorku
  * @param  : None
  * @retval : None
  */
void set_pocet_vzorku() 			//nastaveni poctu vzorku
{
	hodnota=pocet_vzorku;				//ulozime do promenne hodnota
	LCD_Clear();
	set_cursor(0,0);	 			 		// nastavi pozici cursoru LCD na (sloupec, radek)
	printLCD("Pocet vzorku   ");
	nastav_hodnotu();
	pocet_vzorku=hodnota;	  		// ulozeni nastavene hodnoty do promenne
	zbyva_vzorku=hodnota;				// inicializace poctu zbyvajicich vzorku 
	DMA_my_config(pocet_vzorku);// konfigurace DMA pro ukladani vzorku z DMA kanalu
	Delay(100);
}

/**
  * @brief  Obsluha nastaveni jednotek pro nastaveni intervalu odmerovani vzorku
  * @param  : None
  * @retval : None
  */
void set_time_base() //nastaveni casove zakladny pro interval odmerovani
{		
	volba_t_base=3;	
		Delay(100);  //filtr zakmitu tlacitka	
		while(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) // ve smycce pokud je stisk tlacitka PA0 ceka na uvolneni
		{	}

		Delay(100);  //filtr zakmitu tlacitka
		while(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) // ve smycce pokud neni stisk tlacitka PA0
		{							
					if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))
					{ 
						volba_t_base=volba_t_base+1;  //inkrementace volby
						if(volba_t_base>4)
							{volba_t_base=1;}  	//nast max poctu defin. prubehu
					}						
					if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))
					{	
						volba_t_base=volba_t_base-1;
						if(volba_t_base<=0)
							{volba_t_base=4;}	
					}		
					while((!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))||(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))) //cekani pokud je stiskle tlacitko + nebo -
						{}
					Delay(50); //filtr zakmitu
					
			 	 switch(volba_t_base)  //zobrazeni menu voleb na LCD displeji
					{	
						case(1):set_cursor(0,1);printLCD("t_Base*us ms s h");break;  //vypis na display	
						case(2):set_cursor(0,1);printLCD("t_Base us*ms s h");break;  //vypis na display	
						case(3):set_cursor(0,1);printLCD("t_Base us ms*s h");break;  //vypis na display 
						case(4):set_cursor(0,1);printLCD("t_Base us ms s*h");break;  //vypis na display 
					}
				} // while end
				switch(volba_t_base) // spusteni nastaveni v zavislosti na predchozi volbe 
					{	
						case(1):TIM2->PSC=47;time_set_scale=1;break;  				//nastaven clk pro tim2 na T=1us
						case(2):TIM2->PSC=47999;time_set_scale=1;break;  			//nastaven clk pro tim2 na T=1ms
						case(3):TIM2->PSC=47999;time_set_scale=1000;break;  	//nastaven clk pro tim2 na T=1ms nastavena hodnota se nasobi 1000 zadani v sec
						case(4):TIM2->PSC=47999;time_set_scale=3600000;break; //nastaveni na hodiny v ms omezeni citace max 1193hod
					}	
}

/**
  * @brief  Obsluha nastaveni hodnoty intervalu odebirani vzorku
  * @param  : None
  * @retval : None
  */
void set_interval_odberu()		 		// nastaveni intervalu odberu vzorku 
{
	LCD_Clear();
	set_cursor(0,0);	 			 				// nastavi pozici cursoru LCD na (sloupec, radek)
		printLCD("Interval odberu ");
	set_time_base();
	hodnota=interval_odberu;
	nastav_hodnotu();
	interval_odberu=hodnota;	  		// ulozeni nastavene hodnoty do promenne
	TIM2->ARR=time_set_scale*interval_odberu;  // fill autoreload register vel.32bit  1000=1ms  cislo+1+2us(program) =vysledny cas us 0.1s
	Delay(100);
}

/**
  * @brief  Obsluha nastaveni hodnoty na displeji
  * @param  : None
  * @retval : Hodnota
  */
void nastav_hodnotu()
{   
	int rad;
	set_cursor (0,1);
	printLCD("                ");
		set_cursor (3,1);
		PosliPrikazLCD(0x0F);			// 0b00001111 zapnuti blikani kurzoru aby se vedelo kde se nastavuje
	
		for(rad=0;rad<pocet_radu;rad++)
		{		while(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) // cekani na stisk tlacitka posunuti na vyssi rad
				{} 
				Delay(50);	
			obnov_data_display(rad);  // vykresli nast hodnotu na display
	
			while(!GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_0)) //uvolnene tlacitko SET zadava se
			{ 			
				if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))  //je sepnute tlacitko "+" ?
				{
					hodnota=hodnota+pow(10,rad);
					if(hodnota>max_hodn)					//omezeni preteceni
					{hodnota=max_hodn;}
					obnov_data_display(rad);  // vykresli nast hodnotu na display
				}
				if(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2))  //je sepnute tlacitko "-" ?
				{
					hodnota=hodnota-pow(10,rad);
					obnov_data_display(rad);  // vykresli nast hodnotu na display
				}
				while((!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1))||(!GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_2)))
				{}  // pro zmenu hodnoty neni mozne drzet stisknute tlacitko zustane v teto smycce				
				Delay(50);
			}
		}
  PosliPrikazLCD(0x0C);				 	// 0b00001110 vypnuti blikani kurzoru   
}

/**
  * @brief  Obnoveni textu na displeji pri nastavovani hodnoty
  * @param  : None
  * @retval : None
  */
void obnov_data_display(int rad) //obnoveni displeje pri nastaveni hodnoty
{
			set_cursor(6,1);
				itoa(hodnota,LCD_text);
				printLCD(LCD_text);	
			set_cursor (10-rad,1);  // pouze nastavi kurzor do pozici zmeny
}

/**
  * @brief  Obnoveni vsech hodnot displeje pri mereni
  * @param  : None
  * @retval : None
  */
void zobraz_data_signal() 		// obnoveni hodnot displeje pri mereni
{	/***************Prvni radek****************************************/
	//LCD_Clear();
	set_cursor(0,0);
	if(datalog_bezi)
		{printLCD("V:*");}
		else{printLCD("V: ");}		// info o celkovem poctu vzorku k odberu
	set_cursor(3,0);	
		itoa(pocet_vzorku,LCD_text);
		printLCD(LCD_text);	
	
	set_cursor(8,0);	 
	switch(volba_t_base) 				// tisk na display v zavislosti volbe intervalu odmerovani
					{	
						case(1):printLCD("uI:");break;  	//nastaven intervalu na us
						case(2):printLCD("mI:");break;  	//nastaven intervalu na ms
						case(3):printLCD("sI:");break;  	//pokud je nastaven intervalu na sec
						case(4):printLCD("hI:");break;		//pokud je nastaven intervalu na hodiny
						default:printLCD("xI:");break;		//pokud neni nastav zadny intervalu 
					}	
		
	set_cursor(11,0);	
		itoa(interval_odberu,LCD_text);
		printLCD(LCD_text);	
	
	/***************Druhy radek******************************************/
	set_cursor(0,1);   				 // info o zbyvajicim poctu vzorku
		printLCD("R: "); 
	set_cursor(3,1);	
		itoa(zbyva_vzorku,LCD_text);
		printLCD(LCD_text);	
	
	set_cursor(8,1);					// info o zbyvajicim aktualnim stavu ADC
		printLCD(" A:");
	set_cursor(11,1);	
		itoa(ADC_akt_hodnota,LCD_text);
		printLCD(LCD_text);	
}


